/*  GnuPOS-P.h                         */
/*  header file for private data       */

typedef struct
{
  GdkColor   *fg;  /* Foreground colour */
  GdkColor   *bg;  /* Background colour */
  GdkFont    *font; /* Font to use      */
  gint       height; /* Size (in pixels) */

  gchar       textbuf[250];
                   /* Text buffer       */
} topbox_data_struct;

typedef struct
{
  GdkColor   *fg;  /* Foreground colour */
  GdkColor   *bg;  /* Background colour */
  GdkFont    *font; /* Font to use      */

  gchar       textbuf[250];
                   /* Text buffer       */
} rightbox_data_struct;

typedef struct
{
  GdkColor   *fg;  /* Foreground colour */
  GdkColor   *bg;  /* Background colour */
  GdkFont    *font; /* Font to use      */

  gchar       textbuf[250];
                   /* Text buffer       */
} leftbox_data_struct;

typedef struct
{
  GtkWidget  *topbox;          /* pointer to it  */
  GtkWidget  *rightbox;        /* pointer to it  */
  GtkWidget  *leftbox;         /* pointer to it  */

  topbox_data_struct   top;    /* topbox   */
  rightbox_data_struct right;  /* rightbox */
  leftbox_data_struct  left;   /* leftbox  */
  
  guint                 height; /* Height of rightbox and leftbox */
  guint                 width;  /* Width of topbox (total window width) */
  gboolean             show_right; /* rightbox visible? */
  gboolean             show_left;  /* leftbox visible?  */
} mainwindow_data_struct;

typedef struct
{
  gchar              *name;     /* Name of state  */
} state_name_lookup_struct;

typedef struct
{
  guint           function;     /* funciton to execute  */
  guint           parameter;    /* parameter to execute on */
  void           *next;         /* pointer to next instance */
} commands_struct;

typedef struct
{
  guint            inpchar;     /* character or special that triggers input */
  guint            endstate; /* State to switch to if match  */
  void             *commands_struct; /* function to perform  */
  void             *next;    /* pointer to next input */
} state_input_struct;

typedef struct
{
  state_input_struct  (*inputs)[]; /* pointer to linked list of inputs */
  gchar              *helptext; /* pointer to helptext to display */
  guint               numinputs; /* counter of how many inputs exist */
} state_instance_struct;

typedef struct
{
  state_instance_struct (*states)[];  /* array of all states */
  guint                 max_states; /* count of how many states */
  guint                 current_state; /* current state index */
} state_master_struct;
